## skrooge 25.1.0

=== CMakeLists.txt ===
#***************************************************************************
#* SPDX-FileCopyrightText: 2024 S. MANKOWSKI stephane@mankowski.fr
#* SPDX-FileCopyrightText: 2024 G. DE BURE support@mankowski.fr
#* SPDX-License-Identifier: GPL-3.0-or-later
#***************************************************************************
MESSAGE( STATUS "..:: CMAKE ROOT ::..")
CMAKE_MINIMUM_REQUIRED(VERSION 3.16.0)
PROJECT(skrooge)

SET(KF_IGNORE_PLATFORM_CHECK TRUE)

ADD_COMPILE_DEFINITIONS(QT_DISABLE_DEPRECATED_BEFORE=0x050F00)
SET(CMAKE_CXX_STANDARD 17)
SET(CMAKE_CXX_STANDARD_REQUIRED ON)

OPTION(SKG_BUILD_TEST "Build the test" ON)
OPTION(SKG_DESIGNER   "Build designer library" ON)
OPTION(SKG_WEBENGINE  "Build Skrooge with WebEngine" ON)
OPTION(SKG_DBUS  "Build with DBUS" ON)
IF(WIN32)
    SET(SKG_WEBENGINE OFF)
    SET(SKG_DESIGNER OFF)
ENDIF(WIN32)

IF(POLICY CMP0063)
  CMAKE_POLICY(SET CMP0063 NEW)
ENDIF(POLICY CMP0063)

SET(QT_MIN_VERSION "5.15.0")
SET(KF_MIN_VERSION "5.102.0")

FIND_PACKAGE(ECM ${KF_MIN_VERSION} REQUIRED NO_MODULE)

SET(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${ECM_MODULE_PATH} ${skrooge_SOURCE_DIR}/cmake/modules)
INCLUDE(ECMInstallIcons)
INCLUDE(KDEInstallDirs)
INCLUDE(KDECompilerSettings)
INCLUDE(KDECMakeSettings)
INCLUDE(FeatureSummary)
INCLUDE(CheckCXXCompilerFlag)
INCLUDE(GenerateExportHeader)
INCLUDE(ECMSetupVersion)
INCLUDE(ECMGenerateHeaders)
INCLUDE(CMakePackageConfigHelpers)
INCLUDE(KDEFrameworkCompilerSettings)

IF(QT_MAJOR_VERSION STREQUAL "6")
    SET(QT_MIN_VERSION "6.3.0")
    SET(KF_MIN_VERSION "6.3.0")
    SET(SKG_DESIGNER OFF)
    ADD_DEFINITIONS(-DSKG_QT6=ON)
ENDIF()

# Qt 6 build
MESSAGE(STATUS "Using Qt${QT_MAJOR_VERSION}/KF${QT_MAJOR_VERSION} to build Skrooge")
ADD_COMPILE_DEFINITIONS(
#    -DQT_NO_CAST_FROM_ASCII
    -DQT_NO_CAST_TO_ASCII
    -DQT_NO_URL_CAST_FROM_STRING
    -DQT_NO_CAST_FROM_BYTEARRAY
    -DQT_DEPRECATED_WARNINGS
    -DQT_STRICT_ITERATORS
)

FIND_PACKAGE(Qt${QT_MAJOR_VERSION} REQUIRED COMPONENTS Widgets Sql Test PrintSupport Svg Xml Concurrent Qml QuickWidgets)

IF(QT_MAJOR_VERSION STREQUAL "5")
    FIND_PACKAGE(Qt5 REQUIRED COMPONENTS Core Script)
ELSE()
    FIND_PACKAGE(Qt6 REQUIRED COMPONENTS Core5Compat)
ENDIf()

IF(SKG_WEBENGINE)
    FIND_PACKAGE(Qt${QT_MAJOR_VERSION} REQUIRED COMPONENTS WebEngineWidgets)
    MESSAGE( STATUS "     Mode WebEngine")
    ADD_DEFINITIONS(-DSKG_WEBENGINE=${SKG_WEBENGINE})
ENDIF(SKG_WEBENGINE)

IF(SKG_DBUS)
    FIND_PACKAGE(Qt${QT_MAJOR_VERSION} REQUIRED COMPONENTS DBus)
    MESSAGE( STATUS "     DBUS enabled")
    ADD_DEFINITIONS(-DSKG_DBUS=${SKG_DBUS})
ELSE(SKG_DBUS)
    MESSAGE( STATUS "     DBUS disabled")
ENDIF(SKG_DBUS)

IF(SKG_DESIGNER)
  FIND_PACKAGE(Qt${QT_MAJOR_VERSION} REQUIRED COMPONENTS Designer )
  FIND_PACKAGE(KF${QT_MAJOR_VERSION} ${KF_MIN_VERSION} REQUIRED COMPONENTS
    DesignerPlugin        # Tier 3
  )
ENDIF(SKG_DESIGNER)

FIND_PACKAGE(KF${QT_MAJOR_VERSION} ${KF_MIN_VERSION} REQUIRED COMPONENTS
  Archive               # Tier 1
  Config                # Tier 1
  CoreAddons            # Tier 1
  I18n                  # Tier 1
  ItemViews             # Tier 1
  WidgetsAddons         # Tier 1
  WindowSystem          # Tier 1
  GuiAddons             # Tier 1
  Completion            # Tier 2
  JobWidgets            # Tier 2
  ConfigWidgets         # Tier 3
  IconThemes            # Tier 3
  KIO                   # Tier 3
  NewStuffCore          # Tier 3
  NewStuff              # Tier 3
  Parts                 # Tier 3
  Wallet                # Tier 3
  XmlGui                # Tier 3
  NotifyConfig          # Tier 3
  Notifications
)

IF(QT_MAJOR_VERSION STREQUAL "5")
    FIND_PACKAGE(KF${QT_MAJOR_VERSION} ${KF_MIN_VERSION} REQUIRED COMPONENTS
        NewStuffQuick
    )
    FIND_PACKAGE(Grantlee5 0.5 REQUIRED)
    SET(GRANTLEE_VERSION ${Grantlee5_VERSION_MAJOR}.${Grantlee5_VERSION_MINOR}.${Grantlee5_VERSION_PATCH})
    MESSAGE( STATUS "     GRANTLEE VERSION    : " ${GRANTLEE_VERSION})
ELSE()
    FIND_PACKAGE(KF${QT_MAJOR_VERSION} ${KF_MIN_VERSION} REQUIRED COMPONENTS
        ColorScheme
        TextTemplate
    )
ENDIF()

FIND_PACKAGE(KF${QT_MAJOR_VERSION}DocTools)

FIND_PACKAGE(PkgConfig REQUIRED)
PKG_CHECK_MODULES(SQLCIPHER REQUIRED sqlcipher)
MESSAGE( STATUS "     Mode SQLCIPHER enabled")
MESSAGE( STATUS "     SQLCIPHER INCLUDE   :  " ${SQLCIPHER_INCLUDE_DIRS})
SET(SQLITE_LIBRARIES ${SQLCIPHER_LIBRARIES})
SET(SQLITE_INCLUDE_DIR ${SQLCIPHER_INCLUDE_DIRS})
link_directories(${SQLCIPHER_LIBRARY_DIRS})

SET_PACKAGE_PROPERTIES(Sqlcipher PROPERTIES DESCRIPTION "Support for encryption"
                       URL "https://www.zetetic.net/sqlcipher/"
                       TYPE REQUIRED)


SET(SKG_VERSION "25.1.0")
SET(SKG_BETA "")
SET(SOVERSION 2)

IF (CMAKE_BUILD_TYPE)
ELSE (CMAKE_BUILD_TYPE)
	SET(CMAKE_BUILD_TYPE profile)
#"release": optimized for speed, no debug symbols or debug messages
#"relwithdebinfo": optimized for speed, debug symbols for backtraces
#"debug": optimized, but debuggable
#"debugfull": no optimizations, full debug support
#"profile": adds coverage flags to debugfull
#"none": the build flags are manually set using the CMAKE_CXX_FLAGS option.
ENDIF (CMAKE_BUILD_TYPE)

FIND_PROGRAM(SKG_BASH bash)
MARK_AS_ADVANCED(SKG_BASH)

SET(EXECUTABLE_OUTPUT_PATH ${PROJECT_BINARY_DIR}/bin)
SET(LIBRARY_OUTPUT_PATH ${PROJECT_BINARY_DIR}/lib)
MESSAGE( STATUS "     PROJECT_SOURCE_DIR      : " ${PROJECT_SOURCE_DIR} )
MESSAGE( STATUS "     PROJECT_BINARY_DIR      : " ${PROJECT_BINARY_DIR} )
MESSAGE( STATUS "     CMAKE_BUILD_TYPE        : " ${CMAKE_BUILD_TYPE} )
MESSAGE( STATUS "     CMAKE_MODULE_PATH       : " ${CMAKE_MODULE_PATH} )
MESSAGE( STATUS "     CMAKE_INSTALL_PREFIX    : " ${CMAKE_INSTALL_PREFIX} )
MESSAGE( STATUS "     SKG_BUILD_TEST          : " ${SKG_BUILD_TEST} )
MESSAGE( STATUS "     SKG_DESIGNER            : " ${SKG_DESIGNER} )
MESSAGE( STATUS "     SKG_WEBENGINE           : " ${SKG_WEBENGINE} )
MESSAGE( STATUS "     SKG_DBUS                : " ${SKG_DBUS} )
MESSAGE( STATUS "     KDE_INSTALL_QTPLUGINDIR : " ${KDE_INSTALL_QTPLUGINDIR})
MESSAGE( STATUS "     KDE_INSTALL_TARGETS_DEFAULT_ARGS : " ${KDE_INSTALL_TARGETS_DEFAULT_ARGS})

#IF(CMAKE_BUILD_TYPE MATCHES "profile")
#  MESSAGE( STATUS "     TRACES              : All traces activated")
  #add_definitions(-DSKGFULLTRACES)
#ELSE(CMAKE_BUILD_TYPE MATCHES "profile")
#  IF(CMAKE_BUILD_TYPE MATCHES "debug" OR SKG_BETA MATCHES "BETA")
    MESSAGE( STATUS "     TRACES              : Some traces activated")
#  ELSE(CMAKE_BUILD_TYPE MATCHES "debug" OR SKG_BETA MATCHES "BETA")
#    MESSAGE( STATUS "     TRACES              : All traces disabled")
#    add_definitions(-DSKGNOTRACES)
#  ENDIF(CMAKE_BUILD_TYPE MATCHES "debug" OR SKG_BETA MATCHES "BETA")
#ENDIF(CMAKE_BUILD_TYPE MATCHES "profile")

# FIX: Qt was built with -reduce-relocations
IF(Qt5_POSITION_INDEPENDENT_CODE)
  SET(CMAKE_POSITION_INDEPENDENT_CODE ON)
ENDIF(Qt5_POSITION_INDEPENDENT_CODE)

ADD_DEFINITIONS(-DSKGVERSION=${SKG_VERSION}${SKG_BETA})
REMOVE_DEFINITIONS(-DQT_NO_CAST_FROM_ASCII)

#Correction bug 207249 vvvv
IF(CMAKE_COMPILER_IS_GNUCXX)
    CHECK_CXX_COMPILER_FLAG("-Wlogical-op" WLOGICALOP)
    IF(WLOGICALOP)
        ADD_COMPILE_OPTIONS(-Wlogical-op)
    ENDIF(WLOGICALOP)

    ADD_COMPILE_OPTIONS(-std=c++17 -Wno-pedantic -Wall -Wextra -Wno-variadic-macros -Wparentheses -Wmissing-braces -Wcast-align -Wcast-qual -Wformat=2 -Winit-self -Wmissing-include-dirs -Woverloaded-virtual -Wsign-promo -Wstrict-null-sentinel -Wundef -Wno-unused)
    #  ADD_COMPILE_OPTIONS(-Wstrict-overflow=5  -Wshadow  -Wctor-dtor-privacy  -Wshadow -Wold-style-cast -Wswitch-default -Wredundant-decls)
ENDIF(CMAKE_COMPILER_IS_GNUCXX)
#Correction bug 207249 ^^^^

#Default installation path
SET(CMAKE_INSTALL_PREFIX ${BUILD_DIR})

# Win32 specific configuration
IF(WIN32)
    ADD_DEFINITIONS(-DSKG_PLATFORM_WIN32)
    IF(CMAKE_COMPILER_IS_GNUCXX)
	SET(CMAKE_SHARED_LINKER_FLAGS "-Wl,--enable-runtime-pseudo-reloc -Wl,--export-all-symbols" CACHE STRING "" FORCE)
    ENDIF(CMAKE_COMPILER_IS_GNUCXX)

    IF (CMAKE_BUILD_TYPE MATCHES RelWithDebInfo)
        ADD_DEFINITIONS( -DQT_DEBUG )
    ENDIF (CMAKE_BUILD_TYPE MATCHES RelWithDebInfo)
ELSE(WIN32)
#To solve Bug 209912:"ldd -u <library>""
#does not work on MACOS, must be done manually		SET(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} -Wl,--as-needed" CACHE STRING "" FORCE)
ENDIF(WIN32)
MESSAGE(STATUS "     CMAKE_SHARED_LINKER_FLAGS : ${CMAKE_SHARED_LINKER_FLAGS}")

#ADD_SUBDIRECTORY
ADD_SUBDIRECTORY(skgsqlcipher)
ADD_SUBDIRECTORY(skgbasemodeler)
ADD_SUBDIRECTORY(skgbankmodeler)
ADD_SUBDIRECTORY(skgbasegui)
ADD_SUBDIRECTORY(skgbankgui)

IF(SKG_DESIGNER)
    ADD_SUBDIRECTORY(skgbaseguidesigner)
    ADD_SUBDIRECTORY(skgbankguidesigner)
ENDIF(SKG_DESIGNER)

ADD_SUBDIRECTORY(plugins)
ADD_SUBDIRECTORY(images)

IF(SKG_BUILD_TEST AND NOT WIN32)
    ADD_SUBDIRECTORY(tests)
ENDIF(SKG_BUILD_TEST AND NOT WIN32)

IF(KF${QT_MAJOR_VERSION}DocTools_FOUND)
  ADD_SUBDIRECTORY(doc)
ENDIF()

#Main application
ADD_SUBDIRECTORY(skrooge)
ADD_SUBDIRECTORY(skroogeconvert)

# ADD_SUBDIRECTORY(skrooge-companion)

#DOXYGEN
ADD_CUSTOM_TARGET(apidox "doxygen" "${PROJECT_SOURCE_DIR}/Doxyfile")

#GENERATE SPLASH SCREEN
CONFIGURE_FILE(scripts/generateSplash.sh.in scripts/generateSplash.sh @ONLY)
ADD_CUSTOM_TARGET(splash "scripts/generateSplash.sh")

#STATIC CODE CHECKS
CONFIGURE_FILE(scripts/codecheck.sh.in scripts/codecheck.sh @ONLY)
ADD_CUSTOM_TARGET(codecheck "scripts/codecheck.sh")

#FULL
CONFIGURE_FILE(scripts/full.sh scripts/full.sh @ONLY)

#PO files
KI18N_INSTALL(po)

FIND_PACKAGE(KF${QT_MAJOR_VERSION}DocTools CONFIG)
IF(KF${QT_MAJOR_VERSION}DocTools_FOUND)
    KDOCTOOLS_INSTALL(po)
ENDIF()

FEATURE_SUMMARY(WHAT ALL INCLUDE_QUIET_PACKAGES FATAL_ON_MISSING_REQUIRED_PACKAGES)

=== skgbankguidesigner/CMakeLists.txt ===
#***************************************************************************
#* SPDX-FileCopyrightText: 2024 S. MANKOWSKI stephane@mankowski.fr
#* SPDX-FileCopyrightText: 2024 G. DE BURE support@mankowski.fr
#* SPDX-License-Identifier: GPL-3.0-or-later
#***************************************************************************
MESSAGE( STATUS "..:: CMAKE SKGBANKGUIDESIGNER ::..")

PROJECT(SKGBANKGUI)

LINK_DIRECTORIES (${LIBRARY_OUTPUT_PATH})

SET(skgbankguidesigner_SRCS ${skgbankgui_SRCS}
    skgquerycreatordesignerplugin.cpp
    skgbkwidgetcollectiondesignerplugin.cpp
    skgpredicatcreatordesignerplugin.cpp
    skgunitcomboboxdesignerplugin.cpp
)

SET(LIBS Qt${QT_MAJOR_VERSION}::Designer skgbankgui)

IF(SKG_WEBENGINE)
    SET(LIBS ${LIBS} Qt${QT_MAJOR_VERSION}::WebEngineWidgets)
ENDIF(SKG_WEBENGINE)

ADD_LIBRARY(skgbankguidesigner SHARED ${skgbankguidesigner_SRCS})
TARGET_LINK_LIBRARIES(skgbankguidesigner LINK_PUBLIC ${LIBS})
GENERATE_EXPORT_HEADER(skgbankguidesigner BASE_NAME skgbankguidesigner)

########### install files ###############
IF(WIN32)
    INSTALL(TARGETS skgbankguidesigner LIBRARY ARCHIVE DESTINATION ${KDE_INSTALL_PLUGINDIR}/designer )
ELSE(WIN32)
    INSTALL(TARGETS skgbankguidesigner LIBRARY DESTINATION ${KDE_INSTALL_PLUGINDIR}/designer )
ENDIF(WIN32)

=== skrooge/CMakeLists.txt ===
#***************************************************************************
#* SPDX-FileCopyrightText: 2024 S. MANKOWSKI stephane@mankowski.fr
#* SPDX-FileCopyrightText: 2024 G. DE BURE support@mankowski.fr
#* SPDX-License-Identifier: GPL-3.0-or-later
#***************************************************************************
MESSAGE( STATUS "..:: CMAKE SKROOGE ::..")

PROJECT(SKROOGE)

FIND_PACKAGE(Qt${QT_MAJOR_VERSION} COMPONENTS QuickControls2 REQUIRED)

FIND_PACKAGE(KF${QT_MAJOR_VERSION} ${KF_MIN_VERSION} REQUIRED COMPONENTS
  DBusAddons               # Tier 1
)

LINK_DIRECTORIES (${LIBRARY_OUTPUT_PATH})

SET(skrooge_SRCS
   main.cpp
 )
INCLUDE(ECMAddAppIcon)
FILE(GLOB ICONS_SRCS "${CMAKE_CURRENT_SOURCE_DIR}/icons_hicolor/[0-9][0-9]-apps-skrooge.png")
ECM_ADD_APP_ICON(skrooge_SRCS ICONS
    "${CMAKE_CURRENT_SOURCE_DIR}/icons_hicolor/256-apps-skrooge.png"
    "${CMAKE_CURRENT_SOURCE_DIR}/icons_hicolor/128-apps-skrooge.png"
    ${ICONS_SRCS})

ADD_EXECUTABLE(skrooge ${skrooge_SRCS})

TARGET_LINK_LIBRARIES(skrooge KF${QT_MAJOR_VERSION}::DBusAddons skgbasemodeler skgbasegui skgbankmodeler skgbankgui Qt${QT_MAJOR_VERSION}::QuickControls2)

########### install files ###############
INSTALL(TARGETS skrooge ${KDE_INSTALL_TARGETS_DEFAULT_ARGS} )
INSTALL(PROGRAMS org.kde.skrooge.desktop  DESTINATION  ${KDE_INSTALL_APPDIR} )
INSTALL(FILES org.kde.skrooge.appdata.xml DESTINATION ${KDE_INSTALL_METAINFODIR} )
INSTALL(DIRECTORY theme DESTINATION ${KDE_INSTALL_DATADIR}/skrooge FILES_MATCHING PATTERN "*.css"
PATTERN ".svn" EXCLUDE
PATTERN "CMakeFiles" EXCLUDE
PATTERN "Testing" EXCLUDE)
INSTALL(FILES ${PROJECT_SOURCE_DIR}/skrooge.notifyrc  DESTINATION  ${KDE_INSTALL_KNOTIFYRCDIR} )

ECM_INSTALL_ICONS(ICONS
    icons_hicolor/16-apps-skrooge-black.png
    icons_hicolor/16-apps-skrooge.png
    icons_hicolor/16-mimetypes-application-x-skg.png
    icons_hicolor/16-mimetypes-application-x-skgc.png
    icons_hicolor/22-apps-skrooge-black.png
    icons_hicolor/22-apps-skrooge.png
    icons_hicolor/22-mimetypes-application-x-skg.png
    icons_hicolor/22-mimetypes-application-x-skgc.png
    icons_hicolor/32-apps-skrooge-black.png
    icons_hicolor/32-apps-skrooge.png
    icons_hicolor/32-mimetypes-application-x-skg.png
    icons_hicolor/32-mimetypes-application-x-skgc.png
    icons_hicolor/48-apps-skrooge-black.png
    icons_hicolor/48-apps-skrooge.png
    icons_hicolor/48-mimetypes-application-x-skg.png
    icons_hicolor/48-mimetypes-application-x-skgc.png 
    icons_hicolor/64-apps-skrooge-black.png
    icons_hicolor/64-apps-skrooge.png
    icons_hicolor/64-mimetypes-application-x-skg.png
    icons_hicolor/64-mimetypes-application-x-skgc.png
    icons_hicolor/128-apps-skrooge-black.png
    icons_hicolor/128-apps-skrooge.png
    icons_hicolor/128-mimetypes-application-x-skg.png
    icons_hicolor/128-mimetypes-application-x-skgc.png
    icons_hicolor/256-apps-skrooge-black.png
    icons_hicolor/256-apps-skrooge.png
    icons_hicolor/256-mimetypes-application-x-skg.png
    icons_hicolor/256-mimetypes-application-x-skgc.png
    icons_hicolor/512-apps-skrooge-black.png
    icons_hicolor/512-apps-skrooge.png
    icons_hicolor/512-mimetypes-application-x-skg.png
    icons_hicolor/512-mimetypes-application-x-skgc.png
    icons_hicolor/sc-apps-skrooge-black.svgz
    icons_hicolor/sc-apps-skrooge-initial.svgz
    icons_hicolor/sc-apps-skrooge.svgz
    icons_hicolor/sc-mimetypes-application-x-skg.svgz
    icons_hicolor/sc-mimetypes-application-x-skgc.svgz
    DESTINATION ${KDE_INSTALL_ICONDIR}
    THEME hicolor
)
if (NOT SHARED_MIME_INFO_MINIMUM_VERSION)
  set(SHARED_MIME_INFO_MINIMUM_VERSION "0.23")
endif (NOT SHARED_MIME_INFO_MINIMUM_VERSION)

FIND_PACKAGE(SharedMimeInfo REQUIRED)

install(FILES x-skg.xml DESTINATION ${KDE_INSTALL_MIMEDIR})
update_xdg_mimetypes(${KDE_INSTALL_MIMEDIR})

=== tests/skgbankmodelertest/CMakeLists.txt ===
#***************************************************************************
#* SPDX-FileCopyrightText: 2024 S. MANKOWSKI stephane@mankowski.fr
#* SPDX-FileCopyrightText: 2024 G. DE BURE support@mankowski.fr
#* SPDX-License-Identifier: GPL-3.0-or-later
#***************************************************************************
MESSAGE( STATUS "..:: CMAKE SKGBANKMODELERTEST ::..")

PROJECT(SKGBANKMODELERTEST)

LINK_DIRECTORIES (${LIBRARY_OUTPUT_PATH})

INCLUDE_DIRECTORIES( ${CMAKE_SOURCE_DIR}/tests/skgbasemodelertest )

#Add test
ENABLE_TESTING()
FILE(GLOB cpp_files "skgtest*.cpp")
LIST(SORT cpp_files)
FOREACH(file ${cpp_files})
    GET_FILENAME_COMPONENT(utname ${file} NAME_WE)
    ADD_EXECUTABLE(${utname} ${file})
    TARGET_LINK_LIBRARIES(${utname} Qt${QT_MAJOR_VERSION}::Core KF${QT_MAJOR_VERSION}::KIOWidgets skgbankmodeler skgbasemodeler)
    ADD_TEST(NAME ${utname} COMMAND ${CMAKE_SOURCE_DIR}/tests/scripts/${utname}.sh)
ENDFOREACH()
INCLUDE(CTest)

=== tests/skroogetest/CMakeLists.txt ===
#***************************************************************************
#* SPDX-FileCopyrightText: 2024 S. MANKOWSKI stephane@mankowski.fr
#* SPDX-FileCopyrightText: 2024 G. DE BURE support@mankowski.fr
#* SPDX-License-Identifier: GPL-3.0-or-later
#***************************************************************************
MESSAGE( STATUS "..:: CMAKE SKROOGETEST ::..")

PROJECT(SKROOGETEST)

LINK_DIRECTORIES (${LIBRARY_OUTPUT_PATH})

#Add test
ENABLE_TESTING()
#ADD_TEST(NAME skg_sikuli_tst_budget COMMAND ${CMAKE_SOURCE_DIR}/tests/scripts/skg_sikuli_tst_budget.sh)
#ADD_TEST(NAME skg_sikuli_tst_operation COMMAND ${CMAKE_SOURCE_DIR}/tests/scripts/skg_sikuli_tst_operation.sh)
#ADD_TEST(NAME skg_sikuli_tst_print COMMAND ${CMAKE_SOURCE_DIR}/tests/scripts/skg_sikuli_tst_print.sh)
#ADD_TEST(NAME skg_sikuli_tst_tracker COMMAND ${CMAKE_SOURCE_DIR}/tests/scripts/skg_sikuli_tst_tracker.sh)
#ADD_TEST(NAME skg_sikuli_tst_search COMMAND ${CMAKE_SOURCE_DIR}/tests/scripts/skg_sikuli_tst_search.sh)
#ADD_TEST(NAME skg_sikuli_tst_unit COMMAND ${CMAKE_SOURCE_DIR}/tests/scripts/skg_sikuli_tst_unit.sh)

ADD_TEST(NAME skroogeconvert COMMAND ${CMAKE_SOURCE_DIR}/tests/scripts/skroogeconvert.sh)

INCLUDE(CTest)

=== plugins/generic/skg_delete/CMakeLists.txt ===
#***************************************************************************
#* SPDX-FileCopyrightText: 2024 S. MANKOWSKI stephane@mankowski.fr
#* SPDX-FileCopyrightText: 2024 G. DE BURE support@mankowski.fr
#* SPDX-License-Identifier: GPL-3.0-or-later
#***************************************************************************
MESSAGE( STATUS "..:: CMAKE PLUGIN_DELETE ::..")

PROJECT(plugin_delete)

LINK_DIRECTORIES (${LIBRARY_OUTPUT_PATH})

SET(skg_delete_SRCS skgdeleteplugin.cpp)

KCOREADDONS_ADD_PLUGIN(skg_delete SOURCES ${skg_delete_SRCS} INSTALL_NAMESPACE "skg_gui")
TARGET_LINK_LIBRARIES(skg_delete KF${QT_MAJOR_VERSION}::Parts skgbasemodeler skgbasegui)

########### install files ###############
INSTALL(FILES ${PROJECT_SOURCE_DIR}/skg_delete.rc  DESTINATION  ${KDE_INSTALL_KXMLGUIDIR}/skg_delete )

=== plugins/import/skrooge_import_mt940/CMakeLists.txt ===
#***************************************************************************
#* SPDX-FileCopyrightText: 2024 S. MANKOWSKI stephane@mankowski.fr
#* SPDX-FileCopyrightText: 2024 G. DE BURE support@mankowski.fr
#* SPDX-License-Identifier: GPL-3.0-or-later
#***************************************************************************
MESSAGE( STATUS "..:: CMAKE PLUGIN_IMPORT_MT940 ::..")

PROJECT(plugin_import_mt940)

LINK_DIRECTORIES (${LIBRARY_OUTPUT_PATH})

SET(skrooge_import_mt940_SRCS
	skgimportpluginmt940.cpp
)

KCOREADDONS_ADD_PLUGIN(skrooge_import_mt940 SOURCES ${skrooge_import_mt940_SRCS} INSTALL_NAMESPACE "skrooge_import")
TARGET_LINK_LIBRARIES(skrooge_import_mt940 KF${QT_MAJOR_VERSION}::Parts skgbasemodeler skgbasegui skgbankmodeler skgbankgui)

########### install files ###############

=== plugins/import/skrooge_import_xhb/CMakeLists.txt ===
#***************************************************************************
#* SPDX-FileCopyrightText: 2024 S. MANKOWSKI stephane@mankowski.fr
#* SPDX-FileCopyrightText: 2024 G. DE BURE support@mankowski.fr
#* SPDX-License-Identifier: GPL-3.0-or-later
#***************************************************************************
MESSAGE( STATUS "..:: CMAKE PLUGIN_IMPORT_XHB ::..")

PROJECT(plugin_import_xhb)

LINK_DIRECTORIES (${LIBRARY_OUTPUT_PATH})

SET(skrooge_import_xhb_SRCS
	skgimportpluginxhb.cpp
)

KCOREADDONS_ADD_PLUGIN(skrooge_import_xhb SOURCES ${skrooge_import_xhb_SRCS} INSTALL_NAMESPACE "skrooge_import")
TARGET_LINK_LIBRARIES(skrooge_import_xhb KF${QT_MAJOR_VERSION}::Parts KF${QT_MAJOR_VERSION}::Archive skgbasemodeler skgbasegui skgbankmodeler skgbankgui)

########### install files ###############

=== plugins/skrooge/skrooge_report/CMakeLists.txt ===
#***************************************************************************
#* SPDX-FileCopyrightText: 2024 S. MANKOWSKI stephane@mankowski.fr
#* SPDX-FileCopyrightText: 2024 G. DE BURE support@mankowski.fr
#* SPDX-License-Identifier: GPL-3.0-or-later
#***************************************************************************
MESSAGE( STATUS "..:: CMAKE PLUGIN_REPORT ::..")

PROJECT(plugin_report)

IF(SKG_BUILD_TEST AND NOT WIN32)
    ADD_SUBDIRECTORY(tests)
ENDIF(SKG_BUILD_TEST AND NOT WIN32)

LINK_DIRECTORIES (${LIBRARY_OUTPUT_PATH})

SET(skrooge_report_SRCS
	skgreportplugin.cpp
	skgreportpluginwidget.cpp
	skgreportboardwidget.cpp)

ki18n_wrap_ui(skrooge_report_SRCS skgreportpluginwidget_base.ui skgreportpluginwidget_pref.ui)
kconfig_add_kcfg_files(skrooge_report_SRCS skgreport_settings.kcfgc )

KCOREADDONS_ADD_PLUGIN(skrooge_report SOURCES ${skrooge_report_SRCS} INSTALL_NAMESPACE "skg_gui")
TARGET_LINK_LIBRARIES(skrooge_report KF${QT_MAJOR_VERSION}::Parts skgbasemodeler skgbasegui skgbankmodeler skgbankgui)

########### install files ###############
INSTALL(FILES ${PROJECT_SOURCE_DIR}/skrooge_report.rc  DESTINATION  ${KDE_INSTALL_KXMLGUIDIR}/skrooge_report )
INSTALL(FILES ${PROJECT_SOURCE_DIR}/skgreport_settings.kcfg  DESTINATION  ${KDE_INSTALL_KCFGDIR} )

=== plugins/generic/skg_debug/tests/CMakeLists.txt ===
#***************************************************************************
#* SPDX-FileCopyrightText: 2024 S. MANKOWSKI stephane@mankowski.fr
#* SPDX-FileCopyrightText: 2024 G. DE BURE support@mankowski.fr
#* SPDX-License-Identifier: GPL-3.0-or-later
#***************************************************************************
MESSAGE( STATUS "..:: CMAKE PLUGIN_DEBUG_TEST ::..")

PROJECT(plugin_debug_test)

ADD_DEFINITIONS(-DQT_GUI_LIB)
LINK_DIRECTORIES (${LIBRARY_OUTPUT_PATH})

INCLUDE_DIRECTORIES( ${CMAKE_SOURCE_DIR}/tests/skgbasemodelertest )

#Add test
ENABLE_TESTING()
FILE(GLOB cpp_files "skgtest*.cpp")
LIST(SORT cpp_files)
FOREACH(file ${cpp_files})
    GET_FILENAME_COMPONENT(utname ${file} NAME_WE)
    SET(SRC ../skgdebugplugin.cpp ../skgdebugpluginwidget.cpp)
    ki18n_wrap_ui(SRC ../skgdebugpluginwidget_base.ui)

    ADD_EXECUTABLE(${utname} ${file} ${SRC})
    TARGET_LINK_LIBRARIES(${utname} Qt${QT_MAJOR_VERSION}::Gui Qt${QT_MAJOR_VERSION}::Core Qt${QT_MAJOR_VERSION}::Test skgbasegui skgbasemodeler)
    ADD_TEST(NAME ${utname} COMMAND ${CMAKE_SOURCE_DIR}/tests/scripts/${utname}.sh)
ENDFOREACH()
INCLUDE(CTest)

=== debian/changelog ===
skrooge (25.1.0-1) unstable; urgency=medium

  * Team upload.

  [ Aurélien COUDERC ]
  * New upstream release (25.1.0).
  * Limit Qt WebEngine dependency to architectures where it’s available
    (amd64 arm64 armhf i386).
  * Release to unstable.

 -- Aurélien COUDERC <coucouf@debian.org>  Mon, 20 Jan 2025 22:48:34 +0100

skrooge (2.33.8-1) experimental; urgency=medium

  * Team upload.

  [ Pino Toscano ]
  * Drop the kinit dependency from skrooge, as kinit has not been needed for
    a long time.

  [ Aurélien COUDERC ]
  * Add/update Stéphane MANKOWSKI’s key in upstream keyring.
  * New upstream pre-release (2.33.8).
  * Build against Qt6, update build-deps and deps with the info from cmake.
  * Update the list of installed files.
  * Build with hardening=+all build hardening flag.

 -- Aurélien COUDERC <coucouf@debian.org>  Sun, 05 Jan 2025 23:39:56 +0100

=== debian/control ===
Source: skrooge
Section: kde
Priority: optional
Maintainer: Debian KDE Extras Team <pkg-kde-extras@lists.alioth.debian.org>
Uploaders: Pino Toscano <pino@debian.org>,
Build-Depends: debhelper-compat (= 13),
               dh-sequence-grantlee,
               dh-sequence-kf6,
               dh-sequence-python3,
               cmake (>= 3.16.0~),
               extra-cmake-modules (>= 5.102.0~),
               gettext,
               libkf6archive-dev (>= 6.3.0~),
               libkf6colorscheme-dev (>= 6.3.0~),
               libkf6completion-dev (>= 6.3.0~),
               libkf6config-dev (>= 6.3.0~),
               libkf6configwidgets-dev (>= 6.3.0~),
               libkf6coreaddons-dev (>= 6.3.0~),
               libkf6doctools-dev,
               libkf6dbusaddons-dev (>= 6.3.0~),
               libkf6guiaddons-dev (>= 6.3.0~),
               libkf6i18n-dev (>= 6.3.0~),
               libkf6iconthemes-dev (>= 6.3.0~),
               libkf6itemviews-dev (>= 6.3.0~),
               libkf6jobwidgets-dev (>= 6.3.0~),
               libkf6kio-dev (>= 6.3.0~),
               libkf6newstuff-dev (>= 6.3.0~),
               libkf6notifications-dev (>= 6.3.0~),
               libkf6notifyconfig-dev (>= 6.3.0~),
               libkf6parts-dev (>= 6.3.0~),
               libkf6runner-dev (>= 6.3.0~),
               libkf6statusnotifieritem-dev (>= 6.3.0~),
               libkf6texttemplate-dev (>= 6.3.0~),
               libkf6wallet-dev (>= 6.3.0~),
               libkf6widgetsaddons-dev (>= 6.3.0~),
               libkf6windowsystem-dev (>= 6.3.0~),
               libkf6xmlgui-dev (>= 6.3.0~),
               libofx-dev,
               libplasmaactivities-dev,
               libsqlcipher-dev,
               pkgconf,
               python3:any,
               qt6-5compat-dev,
               qt6-base-dev,
               qt6-declarative-dev,
               qt6-svg-dev,
               qt6-tools-dev,
               qt6-webengine-dev [amd64 arm64 armhf i386],
               shared-mime-info,
               xsltproc,
Standards-Version: 4.7.0
Rules-Requires-Root: no
Homepage: https://skrooge.org/
Vcs-Git: https://salsa.debian.org/qt-kde-team/extras/skrooge.git
Vcs-Browser: https://salsa.debian.org/qt-kde-team/extras/skrooge

Package: skrooge
Architecture: any
Depends: libqt6sql6-sqlite,
         skrooge-common (= ${source:Version}),
         ${grantlee:Depends},
         ${misc:Depends},
         ${shlibs:Depends},
Recommends: poppler-utils,
Suggests: aqbanking-tools (>= 5.6.10),
Description: personal finance manager for KDE
 Skrooge allows you to manage your personal finances. It is intended to be used
 by individuals who want to keep track of their incomes, expenses and
 investments. Its philosophy is to stay simple and intuitive.
 .
 Here is the list of Skrooge main features:
  * QIF, CSV, KMyMoney, Skrooge,  import/export
  * OFX, QFX, GnuCash, Grisbi, HomeBank import
  * Advanced Graphical Reports
  * Several tabs to help you organize your work
  * Infinite undo/redo
  * Instant filtering on operations and reports
  * Infinite categories levels
  * Mass update of operations
  * Scheduled operations
  * Track refund of your expenses
  * Automatically process operations based on search conditions
  * Multi currencies
  * Dashboard

Package: skrooge-common
Architecture: all
Depends: ${misc:Depends}, ${python3:Depends},
Description: Skrooge architecture independent files
 Skrooge allows you to manage your personal finances. It is intended to be used
 by individuals who want to keep track of their incomes, expenses and
 investments. Its philosophy is to stay simple and intuitive.
 .
 This package contains architecture independent files needed for Skrooge to run
 properly. It also provides Skrooge documentation. Therefore, unless you
 have 'skrooge' package installed, you will hardly find this package useful.

## skrooge 25.4.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -143,7 +143,7 @@
                        TYPE REQUIRED)
 
 
-SET(SKG_VERSION "25.1.0")
+SET(SKG_VERSION "25.4.0")
 SET(SKG_BETA "")
 SET(SOVERSION 2)

=== images/CMakeLists.txt ===
#***************************************************************************
#* SPDX-FileCopyrightText: 2024 S. MANKOWSKI stephane@mankowski.fr
#* SPDX-FileCopyrightText: 2024 G. DE BURE support@mankowski.fr
#* SPDX-License-Identifier: GPL-3.0-or-later
#***************************************************************************
MESSAGE( STATUS "..:: CMAKE IMAGES ::..")

PROJECT(images)

ADD_SUBDIRECTORY( logos )

#GENERATE SPLASH SCREEN
CONFIGURE_FILE(${PROJECT_SOURCE_DIR}/splash.svg.in ${PROJECT_BINARY_DIR}/splash.svg @ONLY)

INSTALL(FILES splash.png DESTINATION ${KDE_INSTALL_DATADIR}/skrooge/images)

=== skgbankmodeler/CMakeLists.txt ===
#***************************************************************************
#* SPDX-FileCopyrightText: 2024 S. MANKOWSKI stephane@mankowski.fr
#* SPDX-FileCopyrightText: 2024 G. DE BURE support@mankowski.fr
#* SPDX-License-Identifier: GPL-3.0-or-later
#***************************************************************************
MESSAGE( STATUS "..:: CMAKE SKGBANKMODELER ::..")

PROJECT(SKGBANKMODELER)

LINK_DIRECTORIES (${LIBRARY_OUTPUT_PATH})

SET(skgbankmodeler_SRCS
   skgbankobject.cpp
   skgbudgetobject.cpp
   skgbudgetruleobject.cpp
   skgaccountobject.cpp
   skgoperationobject.cpp
   skgrecurrentoperationobject.cpp
   skgtrackerobject.cpp
   skgpayeeobject.cpp
   skgsuboperationobject.cpp
   skgcategoryobject.cpp
   skgunitobject.cpp
   skgunitvalueobject.cpp
   skgruleobject.cpp
   skginterestobject.cpp
   skgdocumentbank.cpp
   skgimportexportmanager.cpp
   skgimportplugin.cpp
   skgreportbank.cpp
 )

#build a shared library
ADD_LIBRARY(skgbankmodeler SHARED ${skgbankmodeler_SRCS})

#need to link to some other libraries ? just add them here
TARGET_LINK_LIBRARIES(skgbankmodeler LINK_PUBLIC KF${QT_MAJOR_VERSION}::Parts Qt${QT_MAJOR_VERSION}::Xml skgbasemodeler)
SET_TARGET_PROPERTIES( skgbankmodeler PROPERTIES VERSION ${SKG_VERSION} SOVERSION ${SOVERSION} )

GENERATE_EXPORT_HEADER(skgbankmodeler BASE_NAME skgbankmodeler)

ADD_SUBDIRECTORY(currency)

########### install files ###############
INSTALL(TARGETS skgbankmodeler ${KDE_INSTALL_TARGETS_DEFAULT_ARGS}  LIBRARY NAMELINK_SKIP)
INSTALL(DIRECTORY sources/. DESTINATION ${KDE_INSTALL_DATADIR}/skrooge_source FILES_MATCHING PATTERN "*.json")

INSTALL(PROGRAMS skrooge-cryptocompare.py DESTINATION ${KDE_INSTALL_DATADIR}/skrooge)
INSTALL(PROGRAMS skrooge-coinmarketcap.py DESTINATION ${KDE_INSTALL_DATADIR}/skrooge)
INSTALL(PROGRAMS skrooge-exchangerates.py DESTINATION ${KDE_INSTALL_DATADIR}/skrooge)
INSTALL(PROGRAMS skrooge-exchangerates_apilayer.py DESTINATION ${KDE_INSTALL_DATADIR}/skrooge)
INSTALL(PROGRAMS skrooge-boursorama.py DESTINATION ${KDE_INSTALL_DATADIR}/skrooge)

=== skgbasegui/CMakeLists.txt ===
#***************************************************************************
#* SPDX-FileCopyrightText: 2024 S. MANKOWSKI stephane@mankowski.fr
#* SPDX-FileCopyrightText: 2024 G. DE BURE support@mankowski.fr
#* SPDX-License-Identifier: GPL-3.0-or-later
#***************************************************************************
MESSAGE( STATUS "..:: CMAKE SKGBASEGUI ::..")

PROJECT(SKGBASEGUI)

LINK_DIRECTORIES (${LIBRARY_OUTPUT_PATH})

SET(skgbasegui_SRCS
    skgmainpanel.cpp
    skgmenuitem.cpp
    skgobjectmodelbase.cpp
    skgwidget.cpp
    skgperiodedit.cpp
    skgtabwidget.cpp
    skgtablewidget.cpp
    skgtabpage.cpp
    skginterfaceplugin.cpp
    skgtableview.cpp
    skgfilteredtableview.cpp
    skgtreeview.cpp
    skgcombobox.cpp
    skgcolorbutton.cpp
    skgzoomselector.cpp
    skgcalculatoredit.cpp
    skggraphicsscene.cpp
    skggraphicsview.cpp
    skghtmlboardwidget.cpp
    skgboardwidget.cpp
    skgtablewithgraph.cpp
    skgdateedit.cpp
    skgprogressbar.cpp
    kdateedit.cpp
    kdatepickerpopup.cpp
    kdatevalidator.cpp
    skgsortfilterproxymodel.cpp
    skgflowlayout.cpp
    skgwebview.cpp
    skgshow.cpp
    skgwidgetselector.cpp
    skgsimpleperiodedit.cpp
)

IF(QT_MAJOR_VERSION STREQUAL "6")
SET(LIBS KF${QT_MAJOR_VERSION}::Parts KF${QT_MAJOR_VERSION}::KIOFileWidgets KF${QT_MAJOR_VERSION}::NotifyConfig KF${QT_MAJOR_VERSION}::Notifications Qt${QT_MAJOR_VERSION}::QuickWidgets Qt${QT_MAJOR_VERSION}::PrintSupport Qt${QT_MAJOR_VERSION}::Svg Qt${QT_MAJOR_VERSION}::Core5Compat skgbasemodeler)
    FIND_PACKAGE(KF${QT_MAJOR_VERSION} ${KF_MIN_VERSION} COMPONENTS StatusNotifierItem)
    if (StatusNotifierItem_FOUND)
        message(STATUS "StatusNotifierItem FOUND")
        SET(LIBS ${LIBS} KF${QT_MAJOR_VERSION}::StatusNotifierItem)
        set(HAS_STATUSNOTIFIER TRUE)
    endif()
ELSE()
    SET(LIBS KF${QT_MAJOR_VERSION}::Parts KF${QT_MAJOR_VERSION}::KIOFileWidgets KF${QT_MAJOR_VERSION}::NotifyConfig KF${QT_MAJOR_VERSION}::Notifications Qt${QT_MAJOR_VERSION}::QuickWidgets Qt${QT_MAJOR_VERSION}::PrintSupport Qt${QT_MAJOR_VERSION}::Svg skgbasemodeler)
ENDIF()
IF(SKG_WEBENGINE)
    SET(LIBS ${LIBS} Qt${QT_MAJOR_VERSION}::WebEngineWidgets)
ENDIF(SKG_WEBENGINE)

IF(QT_MAJOR_VERSION STREQUAL "6")
    find_package(PlasmaActivities)
    if (PlasmaActivities_FOUND)
        message(STATUS "PlasmaActivities FOUND")
        SET(LIBS ${LIBS} Plasma::Activities)
        set(HAS_ACTIVITIES TRUE)
    endif()
else()
    find_package(KF5Activities)
    if (KF5Activities_FOUND)
        message(STATUS "KF5Activities FOUND")
        SET(LIBS ${LIBS} KF5::Activities)
        set(HAS_ACTIVITIES TRUE)
    endif()
endif()

ki18n_wrap_ui(skgbasegui_SRCS skgmainpanel_base.ui skgmainpanel_pref.ui skggraphicsview.ui skgtablewithgraph.ui skgcolorbutton.ui skgzoomselector.ui skgperiodedit.ui skgfilteredtableview.ui skgwidgetselector.ui )
kconfig_add_kcfg_files(skgbasegui_SRCS skgbasegui_settings.kcfgc )

ADD_LIBRARY(skgbasegui SHARED ${skgbasegui_SRCS})
TARGET_LINK_LIBRARIES(skgbasegui LINK_PUBLIC ${LIBS})
SET_TARGET_PROPERTIES(skgbasegui PROPERTIES VERSION ${SKG_VERSION} SOVERSION ${SOVERSION} )
GENERATE_EXPORT_HEADER(skgbasegui BASE_NAME skgbasegui)

########### install files ###############
INSTALL(TARGETS skgbasegui ${KDE_INSTALL_TARGETS_DEFAULT_ARGS}  LIBRARY NAMELINK_SKIP  )
INSTALL(FILES ${PROJECT_SOURCE_DIR}/skgmainpanel.rc  DESTINATION  ${KDE_INSTALL_KXMLGUIDIR}/skg )
INSTALL(FILES ${PROJECT_SOURCE_DIR}/skgbasegui_settings.kcfg  DESTINATION  ${KDE_INSTALL_KCFGDIR} )

INSTALL(DIRECTORY icons_breeze/ DESTINATION ${KDE_INSTALL_ICONDIR}/breeze/actions/22 FILES_MATCHING PATTERN "*.svgz")
INSTALL(DIRECTORY icons_breeze-dark/ DESTINATION ${KDE_INSTALL_ICONDIR}/breeze-dark/actions/22 FILES_MATCHING PATTERN "*.svgz")

ECM_INSTALL_ICONS(ICONS
    icons_hicolor/16-actions-skg-chart-bubble.png
    icons_hicolor/22-actions-skg-chart-bubble.png
    icons_hicolor/32-actions-skg-chart-bubble.png
    icons_hicolor/48-actions-skg-chart-bubble.png
    icons_hicolor/64-actions-skg-chart-bubble.png
    icons_hicolor/128-actions-skg-chart-bubble.png
    icons_hicolor/256-actions-skg-chart-bubble.png
    icons_hicolor/512-actions-skg-chart-bubble.png
    icons_hicolor/sc-actions-skg-chart-bubble.svgz
    DESTINATION ${KDE_INSTALL_ICONDIR}
    THEME hicolor
)

=== skgbaseguidesigner/CMakeLists.txt ===
#***************************************************************************
#* SPDX-FileCopyrightText: 2024 S. MANKOWSKI stephane@mankowski.fr
#* SPDX-FileCopyrightText: 2024 G. DE BURE support@mankowski.fr
#* SPDX-License-Identifier: GPL-3.0-or-later
#***************************************************************************
MESSAGE( STATUS "..:: CMAKE SKGBASEGUIDESIGNER ::..")

PROJECT(SKGBASEGUIDESIGNER)

LINK_DIRECTORIES (${LIBRARY_OUTPUT_PATH})

SET(skgbaseguidesigner_SRCS 
    skgwidgetcollectiondesignerplugin.cpp
    skgtabwidgetdesignerplugin.cpp
    skgtablewidgetdesignerplugin.cpp
    skgtableviewdesignerplugin.cpp
    skgfilteredtableviewdesignerplugin.cpp
    skgtreeviewdesignerplugin.cpp
    skgcomboboxdesignerplugin.cpp
    skgcolorbuttondesignerplugin.cpp
    skgwidgetselectordesignerplugin.cpp
    skgwebviewdesignerplugin.cpp
    skgzoomselectordesignerplugin.cpp
    skgcalculatoreditdesignerplugin.cpp
    skggraphicsviewdesignerplugin.cpp
    skgshowdesignerplugin.cpp
    skgtablewithgraphdesignerplugin.cpp
    skgdateeditdesignerplugin.cpp
    skgprogressbardesignerplugin.cpp
    skgperiodeditdesignerplugin.cpp
    skgsimpleperiodeditdesignerplugin.cpp
)

SET(LIBS Qt${QT_MAJOR_VERSION}::Designer skgbasegui)

IF(SKG_WEBENGINE)
    SET(LIBS ${LIBS} Qt${QT_MAJOR_VERSION}::WebEngineWidgets)
ENDIF(SKG_WEBENGINE)

ADD_LIBRARY(skgbaseguidesigner SHARED ${skgbaseguidesigner_SRCS})
TARGET_LINK_LIBRARIES(skgbaseguidesigner LINK_PUBLIC ${LIBS})
GENERATE_EXPORT_HEADER(skgbaseguidesigner BASE_NAME skgbaseguidesigner)

########### install files ###############
IF(WIN32)
    INSTALL(TARGETS skgbaseguidesigner LIBRARY ARCHIVE DESTINATION ${KDE_INSTALL_PLUGINDIR}/designer )
ELSE(WIN32)
    INSTALL(TARGETS skgbaseguidesigner LIBRARY DESTINATION ${KDE_INSTALL_PLUGINDIR}/designer )
ENDIF(WIN32)

=== skgbasemodeler/CMakeLists.txt ===
#***************************************************************************
#* SPDX-FileCopyrightText: 2024 S. MANKOWSKI stephane@mankowski.fr
#* SPDX-FileCopyrightText: 2024 G. DE BURE support@mankowski.fr
#* SPDX-License-Identifier: GPL-3.0-or-later
#***************************************************************************
MESSAGE( STATUS "..:: CMAKE SKGBASEMODELER ::..")

PROJECT(SKGBASEMODELER)

LINK_DIRECTORIES (${LIBRARY_OUTPUT_PATH})

INCLUDE_DIRECTORIES(${SQLCIPHER_INCLUDE_DIRS})

SET(skgbasemodeler_SRCS
   skgobjectbase.cpp
   skgnamedobject.cpp
   skgnodeobject.cpp
   skgpropertyobject.cpp
   skgdocument.cpp
   skgdocumentprivate.cpp
   skgtransactionmng.cpp
   skgservices.cpp
   skgerror.cpp
   skgtraces.cpp
   skgadvice.cpp
   skgreport.cpp
   skgtreemap.cpp
 )

#build a shared library
ADD_LIBRARY(skgbasemodeler SHARED ${skgbasemodeler_SRCS})

#need to link to some other libraries ? just add them here
SET_TARGET_PROPERTIES(skgbasemodeler PROPERTIES VERSION ${SKG_VERSION} SOVERSION ${SOVERSION} )

TARGET_LINK_LIBRARIES(skgbasemodeler PUBLIC KF${QT_MAJOR_VERSION}::I18n KF${QT_MAJOR_VERSION}::ConfigWidgets KF${QT_MAJOR_VERSION}::CoreAddons
    Qt${QT_MAJOR_VERSION}::Core Qt${QT_MAJOR_VERSION}::Gui Qt${QT_MAJOR_VERSION}::Sql Qt${QT_MAJOR_VERSION}::Qml Qt${QT_MAJOR_VERSION}::Xml Qt${QT_MAJOR_VERSION}::DBus Qt${QT_MAJOR_VERSION}::Concurrent
    KF${QT_MAJOR_VERSION}::KIOCore ${SQLCIPHER_LIBRARIES} KF${QT_MAJOR_VERSION}::IconThemes)
IF(QT_MAJOR_VERSION STREQUAL "6")
    TARGET_LINK_LIBRARIES(skgbasemodeler PUBLIC KF6::TextTemplate)
ELSE()
    TARGET_LINK_LIBRARIES(skgbasemodeler PUBLIC Qt${QT_MAJOR_VERSION}::Script Grantlee5::Templates)
ENDIF()

GENERATE_EXPORT_HEADER(skgbasemodeler BASE_NAME skgbasemodeler)

########### install files ###############
INSTALL(TARGETS skgbasemodeler ${KDE_INSTALL_TARGETS_DEFAULT_ARGS}  LIBRARY NAMELINK_SKIP )

=== skgsqlcipher/CMakeLists.txt ===
#***************************************************************************
#* SPDX-FileCopyrightText: 2024 S. MANKOWSKI stephane@mankowski.fr
#* SPDX-FileCopyrightText: 2024 G. DE BURE support@mankowski.fr
#* SPDX-License-Identifier: GPL-3.0-or-later
#***************************************************************************
MESSAGE( STATUS "..:: SKGSQLCIPHER ::..")

PROJECT(skgsqlcipher)

LINK_DIRECTORIES (${LIBRARY_OUTPUT_PATH})

IF(QT_MAJOR_VERSION STREQUAL "5")
    SET(skgsqlcipher_sources skgsqlcipherdriverplugin.cpp qsql_sqlite.cpp)
    ADD_LIBRARY(libskgsqlcipher MODULE ${skgsqlcipher_sources})
    TARGET_INCLUDE_DIRECTORIES(libskgsqlcipher PRIVATE ${Qt5Sql_PRIVATE_INCLUDE_DIRS} ${SQLCIPHER_INCLUDE_DIRS})
ELSE()
    SET(skgsqlcipher_sources skgsqlcipherdriverplugin.cpp q6sql_sqlite.cpp)
    ADD_LIBRARY(libskgsqlcipher MODULE ${skgsqlcipher_sources})
    TARGET_INCLUDE_DIRECTORIES(libskgsqlcipher PRIVATE ${Qt6Sql_PRIVATE_INCLUDE_DIRS} ${SQLCIPHER_INCLUDE_DIRS})
ENDIF()
TARGET_LINK_LIBRARIES(libskgsqlcipher Qt${QT_MAJOR_VERSION}::Sql ${SQLCIPHER_LIBRARIES})

GENERATE_EXPORT_HEADER(libskgsqlcipher BASE_NAME skgsqlcipher)

########### install files ###############
INSTALL(TARGETS libskgsqlcipher DESTINATION ${KDE_INSTALL_QTPLUGINDIR}/sqldrivers)

=== skroogeconvert/CMakeLists.txt ===
#***************************************************************************
#* SPDX-FileCopyrightText: 2024 S. MANKOWSKI stephane@mankowski.fr
#* SPDX-FileCopyrightText: 2024 G. DE BURE support@mankowski.fr
#* SPDX-License-Identifier: GPL-3.0-or-later
#***************************************************************************
MESSAGE( STATUS "..:: CMAKE SKROOGECONVERT ::..")

PROJECT(SKROOGECONVERT)

INCLUDE(ECMMarkNonGuiExecutable)

LINK_DIRECTORIES (${LIBRARY_OUTPUT_PATH})

SET(skroogeconvert_SRCS
   main.cpp
 )
ADD_EXECUTABLE(skroogeconvert ${skroogeconvert_SRCS})
ECM_MARK_NONGUI_EXECUTABLE(skroogeconvert)

TARGET_LINK_LIBRARIES(skroogeconvert Qt${QT_MAJOR_VERSION}::Widgets skgbasemodeler skgbankmodeler)

########### install files ###############
INSTALL(TARGETS skroogeconvert ${KDE_INSTALL_TARGETS_DEFAULT_ARGS} )

=== tests/skgbaseguitest/CMakeLists.txt ===
#***************************************************************************
#* SPDX-FileCopyrightText: 2024 S. MANKOWSKI stephane@mankowski.fr
#* SPDX-FileCopyrightText: 2024 G. DE BURE support@mankowski.fr
#* SPDX-License-Identifier: GPL-3.0-or-later
#***************************************************************************
MESSAGE( STATUS "..:: CMAKE SKGBASEGUITEST ::..")

PROJECT(SKBBASEMODELERTEST)

ADD_DEFINITIONS(-DQT_GUI_LIB)
LINK_DIRECTORIES (${LIBRARY_OUTPUT_PATH})

INCLUDE_DIRECTORIES( ${CMAKE_SOURCE_DIR}/tests/skgbasemodelertest )

#Add test
ENABLE_TESTING()
FILE(GLOB cpp_files "skgtest*.cpp")
LIST(SORT cpp_files)
FOREACH(file ${cpp_files})
    GET_FILENAME_COMPONENT(utname ${file} NAME_WE)
    if ((NOT SKG_DESIGNER) AND (utname STREQUAL "skgtestwidgetcollection"))
        continue()
    endif()
    ADD_EXECUTABLE(${utname} ${file})
    TARGET_LINK_LIBRARIES(${utname} Qt${QT_MAJOR_VERSION}::Gui Qt${QT_MAJOR_VERSION}::Core Qt${QT_MAJOR_VERSION}::Test skgbasegui skgbasemodeler)
    if (SKG_DESIGNER AND (utname STREQUAL "skgtestwidgetcollection"))
        TARGET_LINK_LIBRARIES(${utname} skgbaseguidesigner)
    endif()
    ADD_TEST(NAME ${utname} COMMAND ${CMAKE_SOURCE_DIR}/tests/scripts/${utname}.sh)
ENDFOREACH()
INCLUDE(CTest)

=== tests/skgmyapplitest/CMakeLists.txt ===
#***************************************************************************
#* SPDX-FileCopyrightText: 2024 S. MANKOWSKI stephane@mankowski.fr
#* SPDX-FileCopyrightText: 2024 G. DE BURE support@mankowski.fr
#* SPDX-License-Identifier: GPL-3.0-or-later
#***************************************************************************
MESSAGE( STATUS "..:: CMAKE SKGMYAPPLITEST ::..")

PROJECT(skgmyapplitest)

LINK_DIRECTORIES (${LIBRARY_OUTPUT_PATH})

SET(skgmyapplitest_SRCS
   main.cpp
 )
kde4_ADD_EXECUTABLE(skgmyapplitest ${skgmyapplitest_SRCS})

TARGET_LINK_LIBRARIES(skgmyapplitest KF${QT_MAJOR_VERSION}::Parts skgbasemodeler skgbasegui )

########### install files ###############
INSTALL(TARGETS skgmyapplitest ${KDE_INSTALL_TARGETS_DEFAULT_ARGS} )
INSTALL(FILES ${PROJECT_SOURCE_DIR}/org.kde.skgmyapplitest.notifyrc  DESTINATION  ${KDE_INSTALL_KNOTIFY5RCDIR} )
INSTALL(PROGRAMS org.kde.skgmyapplitest.desktop  DESTINATION  ${KDE_INSTALL_APPDIR} )
ECM_INSTALL_ICONS( ${KDE_INSTALL_ICONDIR}   )

=== plugins/generic/skg_dashboard/CMakeLists.txt ===
#***************************************************************************
#* SPDX-FileCopyrightText: 2024 S. MANKOWSKI stephane@mankowski.fr
#* SPDX-FileCopyrightText: 2024 G. DE BURE support@mankowski.fr
#* SPDX-License-Identifier: GPL-3.0-or-later
#***************************************************************************
MESSAGE( STATUS "..:: CMAKE PLUGIN_DASHBOARD ::..")

PROJECT(plugin_dashboard)

LINK_DIRECTORIES (${LIBRARY_OUTPUT_PATH})

SET(skg_dashboard_SRCS
	skgdashboardplugin.cpp
	skgdashboardpluginwidget.cpp
        skgdashboardwidget.cpp
        skgdashboardboardwidget.cpp)

KCOREADDONS_ADD_PLUGIN(skg_dashboard SOURCES ${skg_dashboard_SRCS} INSTALL_NAMESPACE "skg_gui")
TARGET_LINK_LIBRARIES(skg_dashboard Qt${QT_MAJOR_VERSION}::Gui KF${QT_MAJOR_VERSION}::Parts skgbasemodeler skgbasegui)

########### install files ###############
INSTALL(FILES ${PROJECT_SOURCE_DIR}/skg_dashboard.rc  DESTINATION  ${KDE_INSTALL_KXMLGUIDIR}/skg_dashboard )

=== plugins/generic/skg_debug/CMakeLists.txt ===
#***************************************************************************
#* SPDX-FileCopyrightText: 2024 S. MANKOWSKI stephane@mankowski.fr
#* SPDX-FileCopyrightText: 2024 G. DE BURE support@mankowski.fr
#* SPDX-License-Identifier: GPL-3.0-or-later
#***************************************************************************
MESSAGE( STATUS "..:: CMAKE PLUGIN_DEBUG ::..")

PROJECT(plugin_debug)

IF(SKG_BUILD_TEST AND NOT WIN32)
    ADD_SUBDIRECTORY(tests)
ENDIF(SKG_BUILD_TEST AND NOT WIN32)

LINK_DIRECTORIES (${LIBRARY_OUTPUT_PATH})

SET(skg_debug_SRCS skgdebugplugin.cpp skgdebugpluginwidget.cpp)

ki18n_wrap_ui(skg_debug_SRCS skgdebugpluginwidget_base.ui)

KCOREADDONS_ADD_PLUGIN(skg_debug SOURCES ${skg_debug_SRCS} INSTALL_NAMESPACE "skg_gui")
TARGET_LINK_LIBRARIES(skg_debug KF${QT_MAJOR_VERSION}::Parts skgbasemodeler skgbasegui Qt${QT_MAJOR_VERSION}::Qml)

########### install files ###############
INSTALL(FILES ${PROJECT_SOURCE_DIR}/skg_debug.rc  DESTINATION  ${KDE_INSTALL_KXMLGUIDIR}/skg_debug )

=== debian/changelog ===
skrooge (25.4.0-1build1) questing; urgency=medium

  * No-change rebuild for Qt 6.9.2 private ABI.

 -- Rik Mills <rikmills@kde.org>  Wed, 17 Sep 2025 06:35:13 +0100

skrooge (25.4.0-1) unstable; urgency=medium

  * New upstream release.
  * Bump Standards-Version to 4.7.2, no changes required.
  * Grantlee is no more used, so:
    - drop the dh-sequence-grantlee build dependency
    - stop using the ${grantlee:Depends} substvar

 -- Pino Toscano <pino@debian.org>  Sat, 26 Apr 2025 11:17:37 +0200

=== debian/control ===
--- 
+++ 
@@ -1,10 +1,10 @@
 Source: skrooge
 Section: kde
 Priority: optional
-Maintainer: Debian KDE Extras Team <pkg-kde-extras@lists.alioth.debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Debian KDE Extras Team <pkg-kde-extras@lists.alioth.debian.org>
 Uploaders: Pino Toscano <pino@debian.org>,
 Build-Depends: debhelper-compat (= 13),
-               dh-sequence-grantlee,
                dh-sequence-kf6,
                dh-sequence-python3,
                cmake (>= 3.16.0~),
@@ -48,7 +48,7 @@
                qt6-webengine-dev [amd64 arm64 armhf i386],
                shared-mime-info,
                xsltproc,
-Standards-Version: 4.7.0
+Standards-Version: 4.7.2
 Rules-Requires-Root: no
 Homepage: https://skrooge.org/
 Vcs-Git: https://salsa.debian.org/qt-kde-team/extras/skrooge.git
@@ -58,7 +58,6 @@
 Architecture: any
 Depends: libqt6sql6-sqlite,
          skrooge-common (= ${source:Version}),
-         ${grantlee:Depends},
          ${misc:Depends},
          ${shlibs:Depends},
 Recommends: poppler-utils,

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

include /usr/share/dpkg/architecture.mk

webengine_archs = amd64 arm64 armhf i386

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -Skf6 -- -DQT_MAJOR_VERSION=6 -DSKG_BUILD_TEST=OFF -DSKG_DESIGNER=OFF -DSKG_WEBKIT=OFF -DSKG_WEBENGINE=$(if $(filter $(DEB_HOST_ARCH), $(webengine_archs)),ON,OFF)

override_dh_auto_test:

override_dh_python3:
	dh_python3 -p skrooge-common /usr/share/skrooge
